searchData={"items":[{"type":"behaviour","title":"DevJoy.Character","doc":"A character is an NPC acting in a game.","ref":"DevJoy.Character.html"},{"type":"behaviour","title":"Data module - DevJoy.Character","doc":"A data module is supposed to fetch character basic information like avatar and full name\nwhich could be entered in your code or fetched from some API or site.\nSuch module needs to implement `c:get_character/1` callback.\n\n    config :dev_joy, DevJoy.Character, data_module: MyApp.DataModule","ref":"DevJoy.Character.html#module-data-module"},{"type":"behaviour","title":"Extra module - DevJoy.Character","doc":"An extra module is supposed to fetch character extra information stored in data field\nwhich could be entered in your code or fetched from some API or site.\nSuch module needs to implement `c:get_character_data/1` callback.\n\n    config :dev_joy, DevJoy.Character, extra_module: MyApp.ExtraModule","ref":"DevJoy.Character.html#module-extra-module"},{"type":"behaviour","title":"Fetching data - DevJoy.Character","doc":"All data is fetched at compile time for every dialog and question.\nIt's recommended to cache all external data in order to avoid long compilation time.","ref":"DevJoy.Character.html#module-fetching-data"},{"type":"callback","title":"DevJoy.Character.get_character/1","doc":"Retrieves information about a character using it's id.","ref":"DevJoy.Character.html#c:get_character/1"},{"type":"callback","title":"DevJoy.Character.get_character_data/1","doc":"Retrieves information about a character using it's id.","ref":"DevJoy.Character.html#c:get_character_data/1"},{"type":"function","title":"DevJoy.Character.get_fields!/1","doc":"Gets a data and extra module from configuration.\nUsing a data module it retrieves information about a character using their id.\nUsing an extra module it retrieves additional data for a character using their id.","ref":"DevJoy.Character.html#get_fields!/1"},{"type":"type","title":"DevJoy.Character.avatar/0","doc":"External url or ralative path within project","ref":"DevJoy.Character.html#t:avatar/0"},{"type":"type","title":"DevJoy.Character.data/0","doc":"Additional data","ref":"DevJoy.Character.html#t:data/0"},{"type":"type","title":"DevJoy.Character.full_name/0","doc":"Full name","ref":"DevJoy.Character.html#t:full_name/0"},{"type":"type","title":"DevJoy.Character.id/0","doc":"Identifier","ref":"DevJoy.Character.html#t:id/0"},{"type":"type","title":"DevJoy.Character.t/0","doc":"Character struct","ref":"DevJoy.Character.html#t:t/0"},{"type":"module","title":"DevJoy.ForumData","doc":"An example character's data module which fetches forum data using username and Discourse API.\nIt uses only publicly available data which does not requires any authentication.","ref":"DevJoy.ForumData.html"},{"type":"module","title":"Configuration - DevJoy.ForumData","doc":"There are 2 simple steps.\nFirstly instruct a character configuration to use this module.\nSecondly configure this module to use your desired endpoint.\n\n    config :dev_joy, DevJoy.Character, data_module: DevJoy.ForumData\n    config :dev_joy, DevJoy.ForumData, endpoint: \"https://meta.discourse.org\"","ref":"DevJoy.ForumData.html#module-configuration"},{"type":"behaviour","title":"DevJoy.Scene","doc":"Scene defines DSL which stores scene parts within `c:get_part/0` and `c:get_part/1` function.","ref":"DevJoy.Scene.html"},{"type":"behaviour","title":"Examples - DevJoy.Scene","doc":"In order to use the `DevJoy` DSL simply add `use DevJoy.Scene` at the top of your module\n\n    defmodule MyApp.SceneName do\n      use DevJoy.Scene\n\n      # parts DSL goes here\n    end\n\nThe optional translation is done at runtime, so you can use it as same as any other module.\nTo enable runtime translation all you need to do is to pass your gettext module as shown below.\n\n    defmodule MyApp.Gettext do\n      use Gettext, otp_app: :my_app\n    end\n\n    defmodule MyApp.SceneWithGettext do\n      use DevJoy.Scene, gettext_module: MyApp.Gettext\n\n      # parts DSL goes here\n    end","ref":"DevJoy.Scene.html#module-examples"},{"type":"macro","title":"DevJoy.Scene.asset/2","doc":"A DSL for `DevJoy.Scene.Asset` struct","ref":"DevJoy.Scene.html#asset/2"},{"type":"macro","title":"DevJoy.Scene.challenge/2","doc":"A DSL for `DevJoy.Scene.Element.Challenge` struct","ref":"DevJoy.Scene.html#challenge/2"},{"type":"macro","title":"DevJoy.Scene.choice/2","doc":"A DSL for `DevJoy.Scene.Element.Choice` struct","ref":"DevJoy.Scene.html#choice/2"},{"type":"macro","title":"DevJoy.Scene.condition/3","doc":"Returns a quoted anonymous function to place it within `c:get_part/1` function.\nOnce called, function fetches character and passes it along with choices\nto the function defined in second argument.\nThe function in 2nd argument should call an action for one of passed choices.\nThis allows to follow a choice based on a runtime condition.\n\nUnlike in `menu/2` or `question/4` the choices are not supposed to be displayed as buttons\nand therefore their content could be an atom and so since it does not need to be translated\nit should simplify the condition in passed function.","ref":"DevJoy.Scene.html#condition/3"},{"type":"macro","title":"Example - DevJoy.Scene.condition/3","doc":"defmodule MyApp do\n      def some_func(_character, choices) do\n        Enum.random(choices).action()\n      end\n    end\n\n    defmodule MyApp.SceneWithCondition do\n      use DevJoy.Scene\n\n      part :condition do\n        condition :john_doe, &MyApp.some_func/2 do\n          choice :choiceA, goto(:partA)\n          choice :choiceB, goto(:partB)\n        end\n      end\n\n      part :partA do\n        # elements for part A goes here\n      end\n\n      part :partB do\n        # elements for part B goes here\n      end\n    end","ref":"DevJoy.Scene.html#condition/3-example"},{"type":"macro","title":"DevJoy.Scene.dialog/3","doc":"A DSL for `DevJoy.Scene.Element.Dialog` struct","ref":"DevJoy.Scene.html#dialog/3"},{"type":"callback","title":"DevJoy.Scene.get_part/0","doc":"Returns a main part of scene","ref":"DevJoy.Scene.html#c:get_part/0"},{"type":"callback","title":"DevJoy.Scene.get_part/1","doc":"Returns a part of scene","ref":"DevJoy.Scene.html#c:get_part/1"},{"type":"macro","title":"DevJoy.Scene.goto/0","doc":"The same as `goto/2`, but defaults to current scene and `:main` part.","ref":"DevJoy.Scene.html#goto/0"},{"type":"macro","title":"DevJoy.Scene.goto/1","doc":"The same as `goto/2`, but defaults to current scene.","ref":"DevJoy.Scene.html#goto/1"},{"type":"macro","title":"DevJoy.Scene.goto/2","doc":"Returns a quoted anonymous function to place it within `c:get_part/1` function.\nOnce called, function returns a data of specified part.\nThis allows to easily navigate to other part or even scene.","ref":"DevJoy.Scene.html#goto/2"},{"type":"macro","title":"Example - DevJoy.Scene.goto/2","doc":"defmodule MyApp.SceneName do\n      use DevJoy.Scene\n\n      part :partA do\n        goto(:partB)\n      end\n\n      part :partB do\n        goto(MyApp.AnotherSceneName, :partA)\n      end\n    end","ref":"DevJoy.Scene.html#goto/2-example"},{"type":"macro","title":"DevJoy.Scene.menu/2","doc":"A DSL for `DevJoy.Scene.Element.Menu` struct","ref":"DevJoy.Scene.html#menu/2"},{"type":"macro","title":"DevJoy.Scene.part/2","doc":"A DSL for `DevJoy.Scene.Part` struct","ref":"DevJoy.Scene.html#part/2"},{"type":"macro","title":"DevJoy.Scene.question/4","doc":"A DSL for `DevJoy.Scene.Element.Dialog` struct with support for choices","ref":"DevJoy.Scene.html#question/4"},{"type":"macro","title":"Example - DevJoy.Scene.question/4","doc":"defmodule MyApp.SceneWithQuestion do\n      use DevJoy.Scene\n\n      part :question do\n        question :john_doe, \"Example question\" do\n          choice \"Example answer\", goto(:part_name)\n        end\n      end\n    end","ref":"DevJoy.Scene.html#question/4-example"},{"type":"type","title":"DevJoy.Scene.struct_fields/0","doc":"Fields to cast into struct","ref":"DevJoy.Scene.html#t:struct_fields/0"},{"type":"type","title":"DevJoy.Scene.struct_module/0","doc":"Module to which fields are casted","ref":"DevJoy.Scene.html#t:struct_module/0"},{"type":"module","title":"DevJoy.Scene.Asset","doc":"Asset gives a way to display an image, play a sound or work with any other files.\nData allows to configure how the asset should be used.\nFor example the same image may be displayed as a background or inside an image preview popup.\nThe sounds on the other side could be repeated.\nOther files or even directories could be used to show a gallery or open it in external application.","ref":"DevJoy.Scene.Asset.html"},{"type":"module","title":"Example - DevJoy.Scene.Asset","doc":"defmodule MyApp.SceneWithAsset do\n      use DevJoy.Scene\n\n      part :asset do\n        asset \"/path/to/asset\", some: :data\n      end\n    end","ref":"DevJoy.Scene.Asset.html#module-example"},{"type":"function","title":"DevJoy.Scene.Asset.priv_path/2","doc":"Returns absolute path for asset","ref":"DevJoy.Scene.Asset.html#priv_path/2"},{"type":"function","title":"DevJoy.Scene.Asset.static_path/2","doc":"Returns static path for asset","ref":"DevJoy.Scene.Asset.html#static_path/2"},{"type":"type","title":"DevJoy.Scene.Asset.data/0","doc":"Additional data","ref":"DevJoy.Scene.Asset.html#t:data/0"},{"type":"type","title":"DevJoy.Scene.Asset.path/0","doc":"Relative path to file","ref":"DevJoy.Scene.Asset.html#t:path/0"},{"type":"type","title":"DevJoy.Scene.Asset.t/0","doc":"Asset struct","ref":"DevJoy.Scene.Asset.html#t:t/0"},{"type":"module","title":"DevJoy.Scene.Element.Challenge","doc":"Challenge is a polimorfic custom content specific for your game.\nIt could be a mini-game or other custom action user have complete to progress in game.","ref":"DevJoy.Scene.Element.Challenge.html"},{"type":"module","title":"Example - DevJoy.Scene.Element.Challenge","doc":"defmodule MyApp.SceneWithChallenge do\n      use DevJoy.Scene\n\n      part :challenge do\n        challenge :challenge_type, some: :data\n      end\n    end","ref":"DevJoy.Scene.Element.Challenge.html#module-example"},{"type":"type","title":"DevJoy.Scene.Element.Challenge.data/0","doc":"Additional data","ref":"DevJoy.Scene.Element.Challenge.html#t:data/0"},{"type":"type","title":"DevJoy.Scene.Element.Challenge.t/0","doc":"Challenge struct","ref":"DevJoy.Scene.Element.Challenge.html#t:t/0"},{"type":"type","title":"DevJoy.Scene.Element.Challenge.type/0","doc":"Type used to identify challenge","ref":"DevJoy.Scene.Element.Challenge.html#t:type/0"},{"type":"module","title":"DevJoy.Scene.Element.Choice","doc":"Choice visually presented as button gives user a possibility to apply an action.\nIt could be a simple menu item as well as an answer for a character question.\nReturned data may be used to perform a further changes in UI.","ref":"DevJoy.Scene.Element.Choice.html"},{"type":"module","title":"Example - DevJoy.Scene.Element.Choice","doc":"choice = Enum.at(menu_or_question.choices, choice_index)\n    choice.action.()","ref":"DevJoy.Scene.Element.Choice.html#module-example"},{"type":"type","title":"DevJoy.Scene.Element.Choice.action/0","doc":"Function to call","ref":"DevJoy.Scene.Element.Choice.html#t:action/0"},{"type":"type","title":"DevJoy.Scene.Element.Choice.content/0","doc":"Content","ref":"DevJoy.Scene.Element.Choice.html#t:content/0"},{"type":"type","title":"DevJoy.Scene.Element.Choice.t/1","doc":"Choice struct\n\nThe content could be a `t:String.t/0` or `t:atom/0` depending on use case.\nAtom values are not translated no matter if `gettext_module` option is used in scene.","ref":"DevJoy.Scene.Element.Choice.html#t:t/1"},{"type":"module","title":"DevJoy.Scene.Element.Dialog","doc":"A dialog visually represented in dialog box contains a text to be displayed.\nDialog have an optional choices which allows for example to answer a character's question.\nDialog allows to display the character information on opposite side.\nThis adds a bit of flexibility for UI design, so dialogs could be styled as messages in chat application.","ref":"DevJoy.Scene.Element.Dialog.html"},{"type":"module","title":"Example - DevJoy.Scene.Element.Dialog","doc":"defmodule MyApp.SceneWithDialog do\n      use DevJoy.Scene\n\n      part :dialog do\n        dialog :john_doe, \"Example dialog\"\n      end\n    end","ref":"DevJoy.Scene.Element.Dialog.html#module-example"},{"type":"type","title":"DevJoy.Scene.Element.Dialog.content/0","doc":"Dialog box content","ref":"DevJoy.Scene.Element.Dialog.html#t:content/0"},{"type":"type","title":"DevJoy.Scene.Element.Dialog.side/0","doc":"Determines on which side of dialog box character should be placed","ref":"DevJoy.Scene.Element.Dialog.html#t:side/0"},{"type":"type","title":"DevJoy.Scene.Element.Dialog.t/0","doc":"Dialog struct","ref":"DevJoy.Scene.Element.Dialog.html#t:t/0"},{"type":"module","title":"DevJoy.Scene.Element.Menu","doc":"Menu visually represented as a titled list of buttons allows to navigate between scenes and their parts.","ref":"DevJoy.Scene.Element.Menu.html"},{"type":"module","title":"Example - DevJoy.Scene.Element.Menu","doc":"defmodule MyApp.SceneWithMenu do\n      use DevJoy.Scene\n\n      part :menu do\n        menu \"Menu title\" do\n          choice \"Menu item content\", goto(:part_name)\n        end\n      end\n    end","ref":"DevJoy.Scene.Element.Menu.html#module-example"},{"type":"type","title":"DevJoy.Scene.Element.Menu.t/0","doc":"Menu struct","ref":"DevJoy.Scene.Element.Menu.html#t:t/0"},{"type":"type","title":"DevJoy.Scene.Element.Menu.title/0","doc":"Title","ref":"DevJoy.Scene.Element.Menu.html#t:title/0"},{"type":"module","title":"DevJoy.Scene.Part","doc":"A part may be used to split a long scene or adding an alternative scenario.","ref":"DevJoy.Scene.Part.html"},{"type":"module","title":"Example - DevJoy.Scene.Part","doc":"defmodule MyApp.SceneName do\n      use DevJoy.Scene\n\n      part :part_name do\n        # elements DSL goes here\n      end\n    end","ref":"DevJoy.Scene.Part.html#module-example"},{"type":"type","title":"DevJoy.Scene.Part.name/0","doc":"Name used to navigate between parts","ref":"DevJoy.Scene.Part.html#t:name/0"},{"type":"type","title":"DevJoy.Scene.Part.scene/0","doc":"Scene module in which part has been defined","ref":"DevJoy.Scene.Part.html#t:scene/0"},{"type":"type","title":"DevJoy.Scene.Part.t/0","doc":"Part struct","ref":"DevJoy.Scene.Part.html#t:t/0"},{"type":"extras","title":"DevJoy","doc":"# DevJoy\n\nA package to simplify creation of Visual Novel games.\n\n[![Hex.pm License](https://img.shields.io/hexpm/l/dev_joy?color=purple)](https://www.apache.org/licenses/LICENSE-2.0)\n[![Hex.pm Version](https://img.shields.io/hexpm/v/dev_joy?color=blue)](https://hex.pm/packages/dev_joy)\n[![Static Badge](https://img.shields.io/badge/docs-limegreen?label=DevJoy&labelColor=gray)](https://hexdocs.pm/dev_joy)","ref":"dev_joy.html"},{"type":"extras","title":"Installation - DevJoy","doc":"```elixir\ndef deps do\n  [\n    {:dev_joy, \"~> 1.0\"}\n  ]\nend\n```\n\n1. Create a new `phoenix` or `scenic` project or just use existing one\n2. Add `dev_joy` to your dependencies\n3. Add English content using DSL\n4. Add assets to your game\n5. Fetch your first scene\n6. Draw your game following output of `current_scene_module.get_part()` or `current_scene_module.get_part(part_name)`\n7. Optionally translate content using gettext (call `mix gettext.extract`).\n\nExcept drawing you only have to provide a content to the game. To \"draw\" your game all you need to do is to convert structs into `phoenix` templates or `scenic` graphs and style them respectively.","ref":"dev_joy.html#installation"},{"type":"extras","title":"Example scenes - DevJoy","doc":"#","ref":"dev_joy.html#example-scenes"},{"type":"extras","title":"Main menu - DevJoy","doc":"```elixir\ndefmodule MyApp.Scenes.Main do\n  use DevJoy.Scene\n\n  alias MyApp.Scenes.FirstStage\n  alias MyApp.Scenes.SecondStage\n  alias MyApp.Scenes.ThirdStage\n\n  part :main do\n    menu \"Welcome in MyApp!\" do\n      asset \"/assets/main/background1.jpg\", size: :stretch_to_fit, type: :backgound\n      asset \"/assets/main/background1.mp3\", loop: true, type: :background\n      choice \"First stage\", goto(FirstStage, :main)\n      choice \"Second stage\", goto(SecondStage, :main)\n      choice \"Third stage\", goto(ThirdStage, :main)\n      choice \"Settings\", goto(:settings)\n      choice \"Credits\", goto(:credits)\n    end\n  end\n\n  part :credits do\n    dialog :admin, \"Assets: me (spend lots of time on search for free image and sounds)\"\n    dialog :admin, \"Scenario: me (generated it by AI)\"\n    dialog :admin, \"Translations: me (I'm just young kid, so nobody would notice that I have used some random free translator)\"\n    dialog :admin, \"Game fun: … (on TODO list already!)\"\n    dialog :admin, \"Aren't I the best? >^·^<\"\n    goto()\n  end\n\n  part :settings do\n    dialog :admin, \"Still working on it …\"\n    dialog :admin, \"Are you stil here ?!?!\"\n    dialog :admin, \"Oh, please! There are no achievements in this game!\"\n    dialog :admin, \"Seriously …\"\n    dialog :admin, \"Oh, right! I haven't instructed the game to navigate you back to main menu!\"\n    goto()\n  end\nend\n```\n\n#","ref":"dev_joy.html#main-menu"},{"type":"extras","title":"Your game's first stage - DevJoy","doc":"```elixir\ndefmodule MyApp.Scenes.FirstStage do\n  use DevJoy.Scene\n\n  alias MyApp.Scenes.Main\n  alias MyApp.Scenes.SecondStage\n\n  part :main do\n    asset \"/assets/first-stage/background1.jpg\", size: :stretch_to_fit, type: :backgound\n    asset \"/assets/first-stage/background1.mp3\", loop: false, type: :foreground\n    dialog :admin, \"Lorem ipsum …\"\n    challenge :input_next_words, count: 3, for: \"Lorem ipsum\"\n    asset \"/assets/first-stage/admin-bored.jpg\", duration: \"0.5s\", type: :preview\n\n    question :admin, \"Aren't you tired already?\" do\n      choice \"Yes! I'm done!\", goto(Main, :main)\n      choice \"Why? Isn't that just a start?\", goto(SecondStage, :main)\n    end\n  end\nend\n```","ref":"dev_joy.html#your-game-s-first-stage"}],"content_type":"text/markdown"}